﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using System.Web.Security;
using System.Web.SessionState;
using System.Xml.Linq;
using Castle.Windsor;

namespace AutoDbCreate.WebHost
{
    public class Global : System.Web.HttpApplication
    {
        public static WindsorContainer container; 

        protected void Application_Start(object sender, EventArgs e)
        {
            container = new WindsorContainer(Server.MapPath("~/Config/Windsor.config"));

            var app = container.Resolve<Application>();
            app.RegisterFacilities(container.Kernel);
            app.RegisterComponents(container.Kernel);
            app.RegisterRoutes(RouteTable.Routes);
            app.RegisterViewEngines(ViewEngines.Engines);
            app.InitializeStorage(container.Kernel);

            // Tell MVC which controller factory to use. Since we're using 
            // the container to inject some items into the controller we need to use this controller factory
            // that was set up in the component registration.
            ControllerBuilder.Current.SetControllerFactory(container.Resolve<IControllerFactory>());
        }

        

        protected void Application_BeginRequest(object sender, EventArgs e)
        {
            // this ensures Default.aspx will be processed
            var context = ((HttpApplication)sender).Context;
            var relativeFilePath = context.Request.AppRelativeCurrentExecutionFilePath;
            if (relativeFilePath == "~/" || 
                string.Equals(relativeFilePath, "~/default.aspx", StringComparison.InvariantCultureIgnoreCase))
            {
                context.RewritePath("~/Home");
            }
        }

        protected void Application_AuthenticateRequest(object sender, EventArgs e)
        {

        }

        protected void Application_Error(object sender, EventArgs e)
        {

        }

        protected void Session_End(object sender, EventArgs e)
        {

        }

        protected void Application_End(object sender, EventArgs e)
        {

        }
    }
}